apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ gerrit_name }}-slave
  name: {{ gerrit_name }}-slave
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ (gerrit_replicas | int) - 1 }}
  selector:
    matchLabels:
      name: {{ gerrit_name }}-slave
  serviceName: {{ gerrit_name }}-slave
  template:
    metadata:
      labels:
        name: {{ gerrit_name }}-slave
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values:
                - {{ gerrit_name }}
                - {{ gerrit_name }}-slave
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values:
                  - {{ gerrit_name }}
                  - {{ gerrit_name }}-slave
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DB_DRIVER
          value: {{ gerrit_db_type }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: GERRIT_IS_SLAVE
          value: yay
{% if gerrit_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_HOST
          value: {{ gerrit_ms_name }}
{% elif gerrit_db_type == 'postgres' %}
        - name: POSTGRES_HOST
          value: {{ gerrit_pg_name }}
{% endif %}
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='gerrit'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 8080
          timeoutSeconds: 3
        name: gerrit
        ports:
        - containerPort: 8080
        - containerPort: 29418
        readinessProbe:
          failureThreshold: 5
          initialDelaySeconds: 60
          periodSeconds: 60
          tcpSocket:
            port: 8080
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ gerrit_cpu_limit }}"
            memory: "{{ gerrit_memory_limit }}"
          requests:
            cpu: "{{ gerrit_cpu_request }}"
            memory: "{{ gerrit_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if do_ldap and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /config
          name: config
{% if do_ldap %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /var/gerrit/.gerritcodereview
          name: data
          subPath: codereview
        - mountPath: /var/gerrit/data
          name: data
          subPath: data
        - mountPath: /var/gerrit/cache
          name: data
          subPath: cache
        - mountPath: /var/gerrit/db
          name: data
          subPath: db
        - mountPath: /var/gerrit/etc
          name: data
          subPath: etc
        - mountPath: /var/gerrit/git
          name: data
          subPath: git
        - mountPath: /var/gerrit/index
          name: data
          subPath: index
        - mountPath: /var/gerrit/lib
          name: data
          subPath: lib
        - mountPath: /var/gerrit/plugins
          name: data
          subPath: plugins
        - mountPath: /var/gerrit/tmp
          name: data
          subPath: tmp
        - mountPath: /.ssh/id_rsa.pub
          name: sshkey
          subPath: id_rsa.pub
        - mountPath: /.ssh/id_rsa
          name: sshkey
          subPath: id_rsa
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: MY_HOME
          value: /var/gerrit/git
        - name: SSH_USERNAME
          value: admin
        - name: SSHD_PORT
          value: "29419"
        image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        name: sshd
        ports:
        - containerPort: 29419
        resources:
          limits:
            cpu: "{{ sshd_cpu_limit }}"
            memory: "{{ sshd_memory_limit }}"
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /var/gerrit/.gerritcodereview
          name: data
          subPath: codereview
        - mountPath: /var/gerrit/git
          name: data
          subPath: git
        - mountPath: /var/backup/sshd
          name: data
          subPath: etc
        - mountPath: /var/backup/tmp
          name: tmp
        - mountPath: /.ssh/id_rsa.pub
          name: sshkey
          subPath: id_rsa.pub
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ gerrit_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
      - labelSelector:
          matchLabels:
            name: {{ gerrit_name }}-slave
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: config
        secret:
          defaultMode: 0420
          secretName: {{ gerrit_name }}-slave
{% if do_ldap %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
      - name: sshkey
        secret:
          secretName: {{ gerrit_name }}-ssh
      - emptyDir: {}
        name: tmp
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: {{ gerrit_data_capacity }}
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
